//---------------------------------------------------------------------------
#ifndef MLinkLabelH
#define MLinkLabelH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <shellapi.h>

//---------------------------------------------------------------------------
typedef void __fastcall (__closure *FOnError)( TObject *Sender, bool ShellExecuteError, DWORD ErrorCode );
typedef void __fastcall (__closure *FOnSuccess)( TObject *Sender, HINSTANCE Instance );

class MClickedThread; // Forward declaration

class PACKAGE MLinkLabel : public TLabel
{
private:
    AnsiString FCommand;
    AnsiString FArguments;
    MClickedThread *FClickThread;
    bool FToggleUnderline;
    void __fastcall Click();
    void __fastcall DoToggleUnderline();
    void __fastcall MouseEntered(TMessage &msg);
    void __fastcall MouseLeft(TMessage &msg);

    // Events
    FOnSuccess   FSuccess;
    FOnError     FError;
    TNotifyEvent FOnMouseEnter,
                 FOnMouseLeave;
protected:
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(CM_MOUSEENTER, TMessage, MouseEntered)
        MESSAGE_HANDLER(CM_MOUSELEAVE, TMessage, MouseLeft)
    END_MESSAGE_MAP(TLabel)
public:
    __fastcall MLinkLabel(TComponent* Owner);
__published:
    __property AnsiString Command = { read=FCommand, write=FCommand};
    __property AnsiString Arguments = { read=FArguments, write=FArguments };
    __property bool ToggleUnderline = { read=FToggleUnderline, write=FToggleUnderline, default=true };
    __property FOnSuccess OnSuccess = { read=FSuccess, write=FSuccess };
    __property FOnError OnError = { read=FError, write=FError };
    __property TNotifyEvent OnMouseEnter = { read=FOnMouseEnter, write=FOnMouseEnter };
    __property TNotifyEvent OnMouseLeave = { read=FOnMouseLeave, write=FOnMouseLeave };
};

// --

class MClickedThread : public TThread
{
private:
        MLinkLabel *Vcl;
        void __fastcall CallSuccess();
        void __fastcall CallError();
        AnsiString Command;
        AnsiString Arguments;
        HINSTANCE ReturnValue;
protected:
        void __fastcall Execute();
public:
        __fastcall MClickedThread(bool CreateSuspended, MLinkLabel *vcl );
        __fastcall ~MClickedThread();
};

//---------------------------------------------------------------------------
#endif
